<?php

/**
 * Created by PhpStorm.
 * User: francismararaujo
 * Date: 23/10/14
 * Time: 17:07
 */

namespace TecDiet\Controllers;

use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

use TecDiet\Services\LoginService;
use TecDiet\Services\JWT;

class LoginController extends \Zeedhi\Framework\Controller\Simple {

    protected $loginService;

    public function __construct($loginService) {
        $this->loginService = $loginService;
    }

    public function login(Request\Filter $request, Response $response) {
        $credentials = $request->getFilterCriteria()->getConditions();

        if($credentials) {

            $email = $credentials[0]["value"];
            $password = $credentials[1]["value"];

            try {
                $user = $this->loginService->getUser($email, $password);
                if($user) {
                    JWT::unsetSessionCookie("tecdietapp");
                    $token = JWT::generateToken($user['auth']);
                    JWT::setSessionCookie("tecdietapp", $token, 0);    
                
                    $units = $this->loginService->initUnits();
    
                    $response->addDataSet(new DataSet ('User', $units['auth']));
                    $response->addDataSet(new DataSet ('Units', $units['units']));

                }

            }catch(\Exception $e) {
                $response->setCriticalError(new Error($e->getMessage(), $e->getCode()));
            }

        }

    }

}