<?php
namespace TecDiet\Controllers;

use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Error;

use TecDiet\Services\MapKitchenMaidService;

class MapKitchenMaidController extends \Zeedhi\Framework\Controller\Simple {

    protected $mapKitchenMaidService;

    public function __construct(MapKitchenMaidService $mapKitchenMaidService) {
        $this->mapKitchenMaidService = $mapKitchenMaidService;
    }

    public function delivery(Request\DataSet $request, Response $response) {

        $foods = $request->getDataSet()->getRows();

        if($foods) {

            try {

                $this->mapKitchenMaidService->delivery($foods);

            }catch(\Exception $e) {

                $response->setError(new Error($e->getMessage(), $e->getCode()));

            };

        }

    }
    
    public function collect(Request\DataSet $request, Response $response) {

        $foods = $request->getDataSet()->getRows();

        if($foods) {

            try {

                $this->mapKitchenMaidService->collect($foods);

            }catch(\Exception $e) {

                $response->setError(new Error($e->getMessage(), $e->getCode()));

            };

        }

    }

}