var MapKitchenMaidController = function(ApplicationContext, eventAggregator, SynchronizeService, ZHPromise, Environment, localStorageEngine, ScreenService, templateManager, MapNutritionistService) {
    var foodsRepository = ApplicationContext.FoodsRepository;

    this.onEnterWidgetMain = function(widget) {

        var filter = [{
                name: [{
                    name: "patientName",
                    direction: "ASC"
                }],
                operator: "ORDER_BY",
                value: ""
            },
            {
                name: "unit",
                operator: "=",
                value: getLocalVar("__CDFILIAL")
            }
        ];
        widget.reload(filter);
    };

    this.reloadScreenAndClearFilters = function(widget) {
        eventAggregator.publish("reloadMapKitchenMaid", widget);
    };

    eventAggregator.subscribe("reloadMapKitchenMaid", function(widget) {
        widget.typeSearch = '';
        widget.dataSourceFilter = [];
        widget.reload();
    });

    eventAggregator.subscribe('sendDeliverFood', function(serviceData) {
        var widget = serviceData.widget;
        var service = serviceData.service;
        // var index = serviceData.index;
        var promise = ZHPromise.defer();
        service.changed = true;
        service.situation = 'Recolher';
        service.deliveryDate = moment().format('DD/MM/YYYY HH:mm:ss');
        service.deliveryOperator = localStorageEngine.getLocalVar('__CDOPERADOR');
        SynchronizeService.persistOnline('/Foods', '/Foods/delivery', 'DataSet', [service]).then(function() {
            service.changed = false;
            service.__is_new = false;
            foodsRepository.save(service).then(function() {
                widget.reload();
            });
        }, function() {}).finally(function() {
            promise.resolve();
        });
    });

    eventAggregator.subscribe('sendCollectFood', function(serviceData) {
        var widget = serviceData.widget;
        var service = serviceData.service;
        var promise = ZHPromise.defer();
        service.changed = true;
        service.situation = null;
        service.collectDate = moment().format('DD/MM/YYYY HH:mm:ss');
        service.collectOperator = localStorageEngine.getLocalVar('__CDOPERADOR');
        SynchronizeService.persistOnline('/Foods', '/Foods/collect', 'DataSet', [service]).then(function() {
            service.changed = false;
            service.__is_new = false;
            foodsRepository.save(service).then(function() {
                widget.reload();
            });
            foodsRepository.removeFood(service);
        }, function() {}).finally(function() {
            // widget.reload();
            promise.resolve();
        });
    });

    this.closePopup = function(widget) {
        closePopupPrescription(widget);
    };

    function closePopupPrescription(widgetPopup) {
        widgetPopup.currentRow = {};
        widgetPopup.filtredFeedingsForWidget = [];
        ScreenService.closePopup();
        widgetPopup.isVisible = false;
        widgetPopup.container.showMenu = true;
    }

    this.saveNewPrescription = function(widget) {
        var widgetPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var currentRow = widgetPrescricao.currentRow;

        if (currentRow.isNewRegister) {
            currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY HH:mm:ss');
        }
        var msg;
        var filterPatient = [{
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            },
            {
                "name": "id",
                "operator": "=",
                "value": widget.currentRow.id,
            },
            {
                "name": [{
                    "name": "formattedName",
                    "direction": "ASC"
                }],
                "operator": "ORDER_BY",
                "value": ""
            }
        ];
        if (widget.isValid()) {
            localStorageEngine.getDataSource('/Patients', filterPatient).then(function(patient) {
                patient[0].ControlFeedings = [widget.currentRow];
                widget.curPatient = patient[0];
                if (widget.filtredFeedingsForWidget && widget.filtredFeedingsForWidget.length) {
                    var count = widget.filtredFeedingsForWidget.filter(function(feeding) {
                        return feeding.selectedByUser === true;
                    }).length;
                    if (count === 0 && widget.currentRow.dietService !== '4' && widget.currentRow.idformdiet !== '4') {
                        msg = ScreenService.i18n("Selecione algum prato para salvar a prescrição!");
                        ScreenService.showMessage(msg);
                    } else {
                        saveOralPrescription(widget);
                    }
                } else if ((currentRow.idtpservhosp === '0' || currentRow.idtpservhosp === '3' ||
                        currentRow.idtpservhosp === '4') || !currentRow.idtpservhosp) {
                    if (widget.currentRow.dietService === '4' || widget.currentRow.idformdiet === '4') {
                        msg = ScreenService.i18n("Selecione algum prato para salvar a prescrição!");
                        ScreenService.showMessage(msg);
                    } else {
                        msg = ScreenService.i18n("Não há cardápio para a configuração informada!");
                        ScreenService.showMessage(msg);
                    }
                }
            });
        }
    };

    function saveOralPrescription(widget) {
        // var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        // var nonFormatedDate = widget.currentRow.serviceDate;
        var formatedData = moment(widget.currentRow.serviceDate, 'YYYY-MM-DD').format("DD/MM/YYYY");
        widget.currentRow.serviceDate = formatedData !== "Invalid date" ? formatedData : widget.currentRow.serviceDate;
        templateManager.bkpCurrentRowPrescription = angular.copy(widget.currentRow);
        // var currentRow = widget.currentRow;
        // var normalFeedings = widget.filtredFeedingsForWidget;
        if (widget.currentRow.idformdiet === '4' || widget.currentRow.dietService === '4') {
            saveSpecialDiet(widget);
        } else {
            saveNormalFeedingsEdit(widget);
        }
        closePopupPrescription(widget);
    }

    function saveNormalFeedingsEdit(widget) {
        // var widgetPopupPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var widgetPopupPrescricao = widget;
        // var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var currentRow = angular.copy(widgetPopupPrescricao.currentRow);
        var normalFeedings = widgetPopupPrescricao.filtredFeedingsForWidget;
        var filter = [{
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            },
            {
                "name": "id",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__patient')
            },
            {
                "name": "serviceDate",
                "operator": "=",
                "value": moment(currentRow.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY')
            },
            {
                "name": "sequential",
                "operator": "=",
                "value": currentRow.sequential
            },
            {
                "name": "unique",
                "operator": "=",
                "value": ""
            }
        ];
        //var rowsToSave = //createRowsToRelateNormalFeedingsToOralPrescription(currentRow, normalFeedings, widgetDetailsPatient);
        if (normalFeedings && normalFeedings.length) {
            var savedOnline = saveOnlineNormalFeedings(widgetPopupPrescricao, normalFeedings);
            var promisesSaveNormalFeedingsEdit = [];
            savedOnline.then(function(successSaveOnline) {
                if (successSaveOnline) {
                    normalFeedings.forEach(function(normalFeeding) {
                        var filterCopied = angular.copy(filter);
                        filterCopied[filterCopied.length - 1].value = normalFeeding.unique;
                        localStorageEngine.getDataSource("/NormalFeedings", filterCopied).then(function(filteredNormalFeeding) {
                            filteredNormalFeeding[0].changed = !successSaveOnline;
                            filteredNormalFeeding[0].selectedByUser = normalFeeding.selectedByUser;
                            filteredNormalFeeding[0].__is_new = normalFeeding.__is_new;
                            filteredNormalFeeding[0].unit = normalFeeding.unit;
                            filteredNormalFeeding[0].id = normalFeeding.id;
                            filteredNormalFeeding[0].serviceDate = normalFeeding.serviceDate;
                            filteredNormalFeeding[0].observation = normalFeeding.observation;
                            promisesSaveNormalFeedingsEdit.push(localStorageEngine.save("/NormalFeedings", filteredNormalFeeding));
                        });
                    });
                    ZHPromise.all(promisesSaveNormalFeedingsEdit).then(function() {
                        updateControlFeedingRestriction(widget, currentRow);
                    });
                }
            });

        }
    }

    function updateControlFeedingRestriction(widget, prescription) {
        var endUpdate = ZHPromise.defer();
        prescription = {};
        // var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        // var serviceDate = moment(prescription.serviceDate, "DD/MM/YYYY");
        var currentRowPrescription = templateManager.bkpCurrentRowPrescription;
        // if (serviceDate.isValid()) {
        //     serviceDate = prescription.serviceDate;
        // } else {
        //     serviceDate = moment(prescription.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
        // }
        var filterControlFeedings = {
            "id": currentRowPrescription.id,
            // "serviceDate": moment(currentRowPrescription.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY'),
            "serviceDate": currentRowPrescription.serviceDate,
            "DTINCLUSAO": currentRowPrescription.DTINCLUSAO
        };
        // widgetDetailsPatient.wasChanged = true;
        updateProcedurePrescription(widget, filterControlFeedings).then(function() {
            if (Array.isArray(widget.patientsToWarning)) {
                var cdpaciente = widget.curPatient.id;
                var index = widget.patientsToWarning.indexOf(cdpaciente);
                if (index > -1) {
                    widget.patientsToWarning.splice(index, 1);
                }
            }

            ScreenService.showMessage(ScreenService.i18n("Restrições alimentares verificadas com sucesso para esta prescrição!"), 'success');
            endUpdate.resolve();
        }, function() {
            var cdpaciente = widget.curPatient.id;
            if (Array.isArray(widget.patientsToWarning)) {
                var index = widget.patientsToWarning.indexOf(cdpaciente);
                if (index === -1) {
                    widget.patientsToWarning.push(cdpaciente);
                }
            } else {
                widget.patientsToWarning = [];
                widget.patientsToWarning.push(cdpaciente);
            }

            ScreenService.showMessage(ScreenService.i18n("Falha na conexão! Atualize as prescrições no Controle Alimentar para verificar inconsistências com as restrições desse paciente!"));
            endUpdate.resolve();
        });
        return endUpdate;
    }

    function updateProcedurePrescription(widget, filter) {
        var deferred = ZHPromise.defer();
        SynchronizeService.synchronizedIntolerance(widget, filter).then(function(callback) {
            deferred.resolve(callback);
        }, function(callback) {
            deferred.reject(callback);
        });
        return deferred;
    }

    function saveSpecialDiet(widgetPopupPrescricao) {
        // var widgetDetailsPatient = widgetPopupPrescricao.container.getWidget('WidgetDetailsPatient');
        // var currentRow = angular.copy(widgetPopupPrescricao.currentRow);
        // var rows = rowsToInsertUpdateDeleteNormalFeedings(widgetPopupPrescricao);
        var rowsToUpdate = [];
        widgetPopupPrescricao.filtredFeedingsForWidget.forEach(function(feeding) {
            widgetPopupPrescricao.bkpFeedings.forEach(function(bkp) {
                if ((bkp.formulationId === feeding.formulationId && bkp.plateType === feeding.plateType) && !bkp.remove && feeding.key) {
                    rowsToUpdate.push(feeding);
                }
            });
        });
        var normalFeedings = rowsToUpdate;
        var savedOnline;
        var rowsToSave;
        if (Array.isArray(rowsToUpdate) && rowsToUpdate.length) {
            savedOnline = saveOnlineNormalFeedings(widgetPopupPrescricao, rowsToUpdate, rowsToSave);
        }
        savedOnline.then(function(successSaveOnline) {
            normalFeedings.forEach(function(normalFeeding, index) {
                var filter = [{
                    name: 'key',
                    operator: '=',
                    value: ''
                }];
                filter[0].value = normalFeeding.key;
                localStorageEngine.getDataSource("/NormalFeedings", filter).then(function(filteredNormalFeeding) {
                    filteredNormalFeeding = filteredNormalFeeding[0];
                    filteredNormalFeeding.changed = !successSaveOnline;
                    filteredNormalFeeding.selectedByUser = normalFeeding.selectedByUser;
                    filteredNormalFeeding.__is_new = normalFeeding.__is_new;
                    filteredNormalFeeding.unit = normalFeeding.unit;
                    filteredNormalFeeding.id = normalFeeding.id;
                    filteredNormalFeeding.serviceDate = normalFeeding.serviceDate;
                    filteredNormalFeeding.observation = normalFeeding.observation;
                    if (successSaveOnline && successSaveOnline.dataset && successSaveOnline.dataset.error && Array.isArray(successSaveOnline.dataset.error.SEQUENTIAL) && successSaveOnline.dataset.error.SEQUENTIAL.length) {
                        filteredNormalFeeding[0].sequential = successSaveOnline.dataset.error.SEQUENTIAL[index];
                    }
                    localStorageEngine.save("/NormalFeedings", filteredNormalFeeding);
                });
            });

        });
        // saveProfile(widgetDetailsPatient);
    }

    function saveOnlineNormalFeedings(widgetPopupPrescricao, rowsToInsertOrUpdate, rowsToSave) {
        var saveOnline = ZHPromise.defer();
        // var widgetPopupPrescricao = widgetDetailsPatient.container.getWidget('widgetPopupPrescricao');
        if (!rowsToSave) {
            rowsToSave = rowsToInsertOrUpdate;
        }
        SynchronizeService.persistOnline('/NormalFeedings', '/NormalFeedings/save', 'DataSet', rowsToInsertOrUpdate).then(function(callback) {
            var currentRowPrescription = templateManager.bkpCurrentRowPrescription;
            var findParams = {
                'CDFILIAL': currentRowPrescription.unit,
                'type': 'normalFeedings'
            };
            SynchronizeService.persistOnline('/NormalFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callbackPlates) {
                callbackPlates.dataset.Plates.normalFeedings = Array.isArray(callbackPlates.dataset.Plates.normalFeedings) ? callbackPlates.dataset.Plates.normalFeedings : [];
                localStorageEngine.setDataSource('/NormalFeedings', callbackPlates.dataset.Plates.normalFeedings);
                updateControlFeedingRestriction(widgetPopupPrescricao, widgetPopupPrescricao.currentRow).then(function() {
                    saveOnline.reject();
                });
            }, function() {
                if (callback && callback.dataset && callback.dataset.error && Array.isArray(callback.dataset.error.SEQUENTIAL) && Array.isArray(rowsToSave)) {
                    rowsToSave.forEach(function(row, index) {
                        row.unique = callback.dataset.error.SEQUENTIAL[index];
                    });

                    MapNutritionistService.saveOralPrescriptionNormalFeedings(rowsToSave, false);
                }
                updateControlFeedingRestriction(widgetPopupPrescricao, widgetPopupPrescricao.currentRow).then(function() {
                    saveOnline.resolve(callback);
                });
            });
        }, function() {
            if (rowsToSave) {
                if (Array.isArray(rowsToSave)) {
                    rowsToSave.map(function(row) {
                        row.changed = true;
                    });
                } else {
                    rowsToSave.changed = true;
                }
                localStorageEngine.save('/NormalFeedings', rowsToSave).then(function() {
                    var currentRowPrescription = templateManager.bkpCurrentRowPrescription;
                    if (currentRowPrescription.idformdiet !== '4' && currentRowPrescription.dietService !== '4') {
                        updateControlFeedingRestriction(widgetPopupPrescricao, widgetPopupPrescricao.currentRow).then(function() {
                            saveOnline.resolve(false);
                        }).finally(function() {
                            saveOnline.resolve(false);
                        });
                    } else {
                        saveOnline.resolve(false);
                    }
                });
            }
        });
        return saveOnline;
    }
};

Configuration(function(ContextRegister) {
    ContextRegister.register('MapKitchenMaidController', MapKitchenMaidController);
});
