function DashboardService(Environment) {

    this.buildLogItem = function(container) {
        return Environment.getDataSource('/LogSolicitacao', [], null, 999999).then(function(logSolicitacao) {
            var widgetLog = container.getWidget('logSolicitacoes');
            if (logSolicitacao.length) {
                var firstRow = logSolicitacao[0];
                widgetLog.getField('INFO').label = "Último erro";
                widgetLog.dataSource.data = [{
                    INFO: firstRow.DATAHORA
                }];
            } else {
                widgetLog.getField('INFO').label = "Nenhum erro encontrado";
                widgetLog.dataSource.data = [];
            }
        });
    };

    this.buildUnitItem = function(container) {
        var template = "widget/dashboard/grid.html";
        var highlight = getLocalVar('__CDFILIAL') + ' - ' + getLocalVar('__NMFILIAL');
        var id = 123;
        var name = "unidade";
        var label = "Unidade Logada";
        var color = 13;
        var width = 3;
        var events = [{
            "name": "WidgetOnDashboardClick",
            "code": "TrocarUnidadeController.inicializaTrocaUnidade();"
        }];

        return getUnitItemData().then(function(data) {

            var showHeader;
            var dataset;
            var height;

            if (!data.length) {

                showHeader = false;
                height = 1;
                dataset = [{
                    INFO: "Nenhuma informação a ser exibida"
                }];

            } else if (data.length === 1) {

                dataset = data;
                showHeader = true;
                height = 1;

            } else {

                dataset = data;
                showHeader = true;
                height = 2;

            }

            var item = buildItem(id, name, label, color, width, height, showHeader, dataset, template, highlight, events, container);

            var existItem = container.widgets.filter(function(widget) {
                return widget.name === name;
            })[0];

            if (existItem) {

                container.widgets.splice(container.widgets.indexOf(existItem), 1);

            }
            return container.widgets.push(item);

        });

    };

    this.buildEffectiveItem = function() {
        // creating a way to show those informations
    };

    var buildItem = function(id, name, label, color, width, height, showHeader, dataset, template, highlight, events, container) {

        return metaDataFactory.widgetFactory({
            "id": id,
            "name": name,
            "color": color,
            "width": width,
            "height": height,
            "isVisible": true,
            "showHeader": showHeader,
            "label": label,
            "highlight": highlight,
            "template": template,
            "events": events,
            "container": container,
            "fields": [{
                "id": 1,
                "name": "INFO",
                "label": "Informações",
                "align": "left"
            }],
            "dataSource": {
                "data": dataset
            }
        });

    };

    var getUnitItemData = function() {

        var data = [];
        var defaultData = [{
            INFO: "Nenhuma informação a ser exibida"
        }];
        var filtro = [{
            name: "CDFILIAL",
            operator: "=",
            value: getLocalVar('__CDFILIAL')
        }];

        return Environment.getDataSource('/Parametros', filtro, null, 999999).then(function(parametros) {

            if (getLocalVar('importacaoRealizada')) {

                if (getLocalVar('__CDFILIAL') === getLocalVar('__CDFILCENTPME')) {

                    data.push({
                        INFO: 'É uma central de merenda'
                    });

                } else if (!getLocalVar('__CDFILCENTPME')) {

                    data.push({
                        INFO: 'Não possui central de merenda'
                    });

                }

                if (parametros.length) {

                    if (parametros[0].IDUTILALMOX === 'S') {

                        data.push({
                            INFO: 'Possui controle de estoque por almoxarifado'
                        });
                    }

                    if (parametros[0].IDUTILLOTE === 'S') {

                        data.push({
                            INFO: 'Possui controle de estoque por lote'
                        });
                    }
                }

            } else {

                data = defaultData;
            }

            return data;

        });
    };

}
Configuration(function(ContextRegister) {
    ContextRegister.register('DashboardService', DashboardService);
});
