var LoginService = function(LoginRepository, Environment, ZHPromise, $rootScope) {

    var USER_ID = "__CDOPERADOR";
    var USER_NAME = "__NMOPERADOR";
    var BRANCH_OFFICE_ID = "__CDFILIAL";
    var ORGANIZATION_ID = "__NRORGTRAB";
    var USER_MAIL = "__DSEMAILOPER";

    this.getCurrentUser = function() {

        return getLocalVar(USER_ID);
    };

    this.auth = function(email, password) {
        return LoginRepository.auth(email, password).then(function(session) {
            return _initCurrentUser(session.User).then(function() {
                return session;
            }.bind(this));
        });
    };

    var _initCurrentUser = function(user) {

        var promises = [];

        promises.push(setLocalVar(USER_ID, user.CDOPERADOR));
        promises.push(setLocalVar(USER_NAME, user.NMOPERADOR));
        promises.push(setLocalVar(BRANCH_OFFICE_ID, user.CDFILIAL));
        promises.push(setLocalVar(ORGANIZATION_ID, user.NRORG));
        promises.push(setLocalVar(USER_MAIL, user.DSEMAILOPER));

        return ZHPromise.all(promises);

    };

    this.login = function(session) {

        return _initCurrentUser(session.User).then(function() {
            return Environment.afterLogin(session);
        });

    };

    /**
     * Remove user data from local storage
     */
    this.removeUserData = function() {
        localStorage.clear();
    };

    this.logout = function() {

        var promises = [];

        promises.push(setLocalVar(USER_ID, ""));
        promises.push(setLocalVar(USER_NAME, ""));
        promises.push(setLocalVar(BRANCH_OFFICE_ID, ""));
        promises.push(setLocalVar(ORGANIZATION_ID, ""));

        return ZHPromise.all(promises);

    };

    this.setLanguage = function(lang) {

        $rootScope.$broadcast("__words.change", lang);

    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('LoginService', LoginService);
});
